package bluetoothconnect;
import android.app.Activity;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.os.Build;
import android.sax.StartElementListener;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.TextView;







import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

import com.example.bluetooth.le.MenuActivity;
import com.example.bluetooth.le.R;
import com.example.bluetooth.prt.HPRTHelper;
import com.example.bluetooth.prt.HPRTHelper.onConnect;
import com.example.bluetooth.prt.HidConncetUtil;

/**
 * Created by liushen on 2016/5/31.
 */
public class MyBluetoothAdapter extends BaseAdapter {
    private List<BluetoothDevice> mList = new ArrayList<BluetoothDevice>();
    private Context mContext;
    private HidConncetUtil mHidConncetUtil;
	private HPRTHelper mHprt;
    public MyBluetoothAdapter(List<BluetoothDevice> mList, Context mContext) {
        this.mList = mList;
        this.mContext = mContext;
        //4.0ϲ֧HIDģʽ
        if (Build.VERSION.SDK_INT >= 14) {
            this.mHidConncetUtil = new HidConncetUtil(mContext);
            mHprt = HPRTHelper.getHPRTHelper(mContext);
        }
    }
    public MyBluetoothAdapter(Context mContext) {
        this.mContext = mContext;
        //4.0ϲ֧HIDģʽ
        if (Build.VERSION.SDK_INT >= 14) {
            this.mHidConncetUtil = new HidConncetUtil(mContext);
        	mHprt = HPRTHelper.getHPRTHelper(mContext);
        }
    }

    @Override
    public int getCount() {
        return mList.size();
    }

    @Override
    public Object getItem(int position) {
        return mList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    public void addData(List<BluetoothDevice> bluetoothDevice){
    	mList.clear();
        mList.addAll(bluetoothDevice);
    }
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder viewHolder = null;
        if(convertView==null){
            convertView = View.inflate(mContext,R.layout.blue_list_item,null);
            viewHolder = new ViewHolder(convertView);
            convertView.setTag(viewHolder);
        }else{
            viewHolder = (ViewHolder) convertView.getTag();
        }
        initData(position,viewHolder);
        return convertView;
    }

    private void initData(int position,ViewHolder viewHolder) {
        final BluetoothDevice bluetoothDevice = mList.get(position);
        viewHolder.bluehandlename.setText(bluetoothDevice.getName());
        viewHolder.bluehandlebond.setText(bluetoothDevice.getAddress());
        viewHolder.connect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
            	mHprt.setDevice(bluetoothDevice);
            	System.out.println("");
            	mHprt.buleconnect(mHidConncetUtil,mContext,new onConnect() {
					@Override
					public void succeed() {
						// TODO Auto-generated method stub
						System.out.println("succeed");
						Toast.makeText(mContext, "ӳɹ", 0).show();
						mContext.startActivity(new Intent((Activity)mContext, MenuActivity.class));
					}
					
					@Override
					public void failure() {
						// TODO Auto-generated method stub
						System.out.println("failure");
						Toast.makeText(mContext, "ʧ", 0).show();
					}
				});
            }
        });
    }

    /**
     * жǷԲ״̬
     * @param bluetoothDevice
     */
    private void isBonded(BluetoothDevice bluetoothDevice,ViewHolder viewHolder){
        int state =  bluetoothDevice.getBondState();
        switch (state) {
            case BluetoothDevice.BOND_NONE:
                viewHolder.bluehandlebond.setText("δ");
                break;
            case BluetoothDevice.BOND_BONDING:
                viewHolder.bluehandlebond.setText("...");
                break;
            case BluetoothDevice.BOND_BONDED:
                viewHolder.bluehandlebond.setText("");
                break;
        }
    }

    /**
     * жǷ
     * @param bluetoothDevice
     * @param viewHolder
     */
    private void isConnected(final BluetoothDevice bluetoothDevice,final ViewHolder viewHolder){
        if (mHidConncetUtil != null) {
            mHidConncetUtil.getHidConncetList(new HidConncetUtil.GetHidConncetListListener() {
                @Override
                public void getSuccess(ArrayList<BluetoothDevice> list) {
                    //жбǷи豸
                    for(BluetoothDevice bluetoothDevice1:list){
                        if(bluetoothDevice.getAddress().equals(bluetoothDevice1.getAddress())){
                            viewHolder.bluehandlebond.setText("HID");
                            break;
                        }
                    }
                }
            });
        }
    }

    public class ViewHolder {
        public final TextView bluehandlename;
        public final TextView bluehandlebond;
        public final Button connect;
        public final View root;

        public ViewHolder(View root) {
            bluehandlename = (TextView) root.findViewById(R.id.blue_handle_name);
            bluehandlebond = (TextView) root.findViewById(R.id.blue_handle_bond);
            connect = (Button) root.findViewById(R.id.connect);
            this.root = root;
        }
    }
//    public void unBundService(){
//    	mHprt.unBundService();
//    }
//    public void test(){
//    	mHprt.printTest();
//    }
}
