package com.example.bluetooth.le;

import com.example.bluetooth.prt.HPRTHelper;
import com.example.bluetooth.prt.HPRTHelper.onReadData;
import com.example.bluetooth.prt.HPRTHelper.onShock;

import android.app.Activity;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.Editable;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Switch;
import android.widget.Toast;

public class SettingActivity extends Activity implements OnClickListener{

	private RadioGroup rg_enter;
	private RadioGroup rg_letter;
	private RadioGroup rg_scan;
	private RadioGroup rg_sound;
	private RadioGroup rg_shock;
	private RadioButton rb_enter_no;
	private RadioButton rb_enter_yes;
	private RadioButton rb_letter_big;
	private RadioButton rb_letter_originally;
	private RadioButton rb_letter_small;
	private RadioButton rb_scan_no;
	private RadioButton rb_scan_yes;
	private RadioButton rb_sound_no;
	private RadioButton rb_shock_yes;
	private RadioButton rb_shock_no;
	private RadioButton rb_sound_yes;
	private EditText ed_gapsound_time;
	private EditText ed_longsound_time;
	private EditText ed_offpower_time;
	private EditText ed_offscan_time;
	private EditText ed_shock_time;
	private EditText ed_shortsound_number;
	private EditText ed_shortsound_time;
	private EditText ed_sound_number;
	private Button btn_modify;
	private HPRTHelper helper;
	private SettingViewhold settingViewhold;
	private Context mContext;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_setting);
		mContext = getApplicationContext();
		initView();
		initData();
	}

	private void initData() {
		helper = HPRTHelper.getHPRTHelper(mContext);
		getSettingViewhold();
		
	}

	private void initView() {
		rg_enter = (RadioGroup) findViewById(R.id.rg_enter);
		rg_letter = (RadioGroup) findViewById(R.id.rg_letter);
		rg_scan = (RadioGroup) findViewById(R.id.rg_scan);
		rg_sound = (RadioGroup) findViewById(R.id.rg_sound);
		rg_shock = (RadioGroup) findViewById(R.id.rg_shock);
		rb_enter_no = (RadioButton) findViewById(R.id.rb_enter_no);
		rb_enter_yes = (RadioButton) findViewById(R.id.rb_enter_yes);
		rb_letter_big = (RadioButton) findViewById(R.id.rb_letter_big);
		rb_letter_originally = (RadioButton) findViewById(R.id.rb_letter_originally);
		rb_letter_small = (RadioButton) findViewById(R.id.rb_letter_small);
		rb_scan_no = (RadioButton) findViewById(R.id.rb_scan_no);
		rb_scan_yes = (RadioButton) findViewById(R.id.rb_scan_yes);
		rb_sound_no = (RadioButton) findViewById(R.id.rb_sound_no);
		rb_sound_yes = (RadioButton) findViewById(R.id.rb_sound_yes);
		rb_shock_no = (RadioButton) findViewById(R.id.rb_shock_no);
		rb_shock_yes = (RadioButton) findViewById(R.id.rb_shock_yes);
		ed_gapsound_time = (EditText) findViewById(R.id.ed_gapsound_time);
		ed_longsound_time = (EditText) findViewById(R.id.ed_longsound_time);
		ed_offpower_time = (EditText) findViewById(R.id.ed_offpower_time);
		ed_offscan_time = (EditText) findViewById(R.id.ed_offscan_time);
		ed_shock_time = (EditText) findViewById(R.id.ed_shock_time);
		ed_shortsound_number = (EditText) findViewById(R.id.ed_shortsound_number);
		ed_shortsound_time = (EditText) findViewById(R.id.ed_shortsound_time);
		ed_sound_number = (EditText) findViewById(R.id.ed_sound_number);
		btn_modify = (Button) findViewById(R.id.btn_modify);
		btn_modify.setOnClickListener(this);
	}
	private void getSettingViewhold(){
		helper.getSettingData(new onReadData() {
			
			@Override
			public void succeed(byte[] data) {
				settingViewhold = new SettingViewhold(data[8], data[7], data[13], data[14], data[9], data[2], data[3], data[4], data[5], data[6], data[11], data[12]);
				setLetter();
				setEnter();
				setSound();
				setScan();
				setEdtext();
				helper.getShock(new onShock() {
					
					@Override
					public void succeed(byte[] data) {
						// TODO Auto-generated method stub
						if (data[2]==0) {
							rg_shock.check(rb_shock_no.getId());
						}else{
							rg_shock.check(rb_shock_yes.getId());
						}
					}
					
					@Override
					public void failure() {
						// TODO Auto-generated method stub
						Builder dialog = Util.Dialog(SettingActivity.this, "ʼ","ȡʧܣ");
						dialog.setNegativeButton("ȷ", new DialogInterface.OnClickListener() {
							
							@Override
							public void onClick(DialogInterface dialog, int which) {
								// TODO Auto-generated method stub
								finish();
							}
						});
						dialog.show();
					}
				});
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				Builder dialog = Util.Dialog(SettingActivity.this, "ʼ","ȡʧܣ");
				dialog.setNegativeButton("ȷ", new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						finish();
					}
				});
				dialog.show();
			}
		});
	};
	private void setLetter(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getLetter()) {
		case 0:
			rg_letter.check(rb_letter_originally.getId());
			break;
		case 1:
			rg_letter.check(rb_letter_small.getId());
			break;
		case 2:
			rg_letter.check(rb_letter_big.getId());
			break;

		default:
			break;
		}
	}
	private void setEnter(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getEnter()) {
		case 0:
			rg_enter.check(rb_enter_no.getId());
			break;
		case 1:
			rg_enter.check(rb_enter_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void setSound(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getSound()) {
		case 0:
			rg_sound.check(rb_sound_no.getId());
			break;
		case 1:
			rg_sound.check(rb_sound_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void setScan(){
		if (settingViewhold==null) {
			return;
		}
		switch (settingViewhold.getScan()) {
		case 0:
			rg_scan.check(rb_scan_no.getId());
			break;
		case 1:
			rg_scan.check(rb_scan_yes.getId());
			break;
			
		default:
			break;
		}
	}
	private void setEdtext(){
		if (settingViewhold==null) {
			return;
		}
		ed_gapsound_time.setText(settingViewhold.getGapSoundTime()<0?""+(settingViewhold.getGapSoundTime()+256):""+settingViewhold.getGapSoundTime());
		ed_longsound_time.setText(settingViewhold.getLongSoundTime()<0?""+(settingViewhold.getLongSoundTime()+256):""+settingViewhold.getLongSoundTime());
		ed_offpower_time.setText(settingViewhold.getOffPowerTime()<0?""+(settingViewhold.getOffPowerTime()+256):""+settingViewhold.getOffPowerTime());
		ed_offscan_time.setText(settingViewhold.getOffScanTime()<0?""+(settingViewhold.getOffScanTime()+256):""+settingViewhold.getOffScanTime());
		ed_shock_time.setText(settingViewhold.getShockTime()<0?""+(settingViewhold.getShockTime()+256):""+settingViewhold.getShockTime());
		ed_shortsound_number.setText(settingViewhold.getShortSoundNumber()<0?""+(settingViewhold.getShortSoundNumber()+256):""+settingViewhold.getShortSoundNumber());
		ed_shortsound_time.setText(settingViewhold.getShortSoundTime()<0?""+(settingViewhold.getShortSoundTime()+256):""+settingViewhold.getShortSoundTime());
		ed_sound_number.setText(settingViewhold.getSoundNumber()<0?""+(settingViewhold.getSoundNumber()+256):""+settingViewhold.getSoundNumber());
	}
	

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.btn_modify:
			modify();
			break;

		default:
			break;
		}
	}
	private void modify(){
		if (settingViewhold==null) {
			return;
		}
		switch (rg_letter.getCheckedRadioButtonId()) {
		case R.id.rb_letter_originally:
			settingViewhold.setLetter(0);
			break;
		case R.id.rb_letter_small:
			settingViewhold.setLetter(1);
			break;
		case R.id.rb_letter_big:
			settingViewhold.setLetter(2);
			break;
		default:
			break;
		}
		switch (rg_enter.getCheckedRadioButtonId()) {
		case R.id.rb_enter_no:
			settingViewhold.setEnter(0);
			break;
		case R.id.rb_enter_yes:
			settingViewhold.setEnter(1);
			break;
		default:
			break;
		}
		switch (rg_scan.getCheckedRadioButtonId()) {
		case R.id.rb_scan_no:
			settingViewhold.setScan(0);
			break;
		case R.id.rb_scan_yes:
			settingViewhold.setScan(1);
			break;
		default:
			break;
		}
		switch (rg_sound.getCheckedRadioButtonId()) {
		case R.id.rb_sound_no:
			settingViewhold.setSound(0);
			break;
		case R.id.rb_sound_yes:
			settingViewhold.setSound(1);
			break;
		default:
			break;
		}
		if(!Util.chackEdtextNoEmpty(mContext, ed_gapsound_time, "ʱΪ")){
			return;
		}
		int gapSoundTime = Util.chackEdtextArea(mContext, ed_gapsound_time, 1, 5, "ʱΧ");
		if (gapSoundTime==-1) {
			return;
		}
		settingViewhold.setGapSoundTime(gapSoundTime);
		
		if(!Util.chackEdtextNoEmpty(mContext, ed_longsound_time, "ʱΪ")){
			return;
		}
		int longSoundTime = Util.chackEdtextArea(mContext, ed_longsound_time, 3, 30, "ʱΧ");
		if (longSoundTime==-1) {
			return;
		}
		settingViewhold.setLongSoundTime(longSoundTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_offpower_time, "޶ػʱΪ")){
			return;
		}
		int offPowerTime = Util.chackEdtextArea(mContext, ed_offpower_time, 3, 60, "޶ػʱΧ");
		if (offPowerTime==-1) {
			return;
		}
		settingViewhold.setOffPowerTime(offPowerTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_offscan_time, "޶رɨʱΪ")){
			return;
		}
		int offScanTime = Util.chackEdtextArea(mContext, ed_offscan_time, 3, 60, "޶رɨʱΧ");
		if (offScanTime==-1) {
			return;
		}
		settingViewhold.setOffScanTime(offScanTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shock_time, "ʱΪ")){
			return;
		}
		int shockTime = Util.chackEdtextArea(mContext, ed_shock_time, 3, 30, "ʱΧ");
		if (shockTime==-1) {
			return;
		}
		settingViewhold.setShockTime(shockTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shortsound_number, "̵δΪ")){
			return;
		}
		int shortSoundNumber = Util.chackEdtextArea(mContext, ed_shortsound_number, 1, 10, "̵δΧ");
		if (shortSoundNumber==-1) {
			return;
		}
		settingViewhold.setShortSoundNumber(shortSoundNumber);
		if(!Util.chackEdtextNoEmpty(mContext, ed_shortsound_time, "̵ʱΪ")){
			return;
		}
		int shortSoundTime = Util.chackEdtextArea(mContext, ed_shortsound_time, 1, 5, "̵ʱΧ");
		if (shortSoundTime==-1) {
			return;
		}
		settingViewhold.setShortSoundTime(shortSoundTime);
		if(!Util.chackEdtextNoEmpty(mContext, ed_sound_number, "СΪ")){
			return;
		}
		int soundNumber = Util.chackEdtextArea(mContext, ed_sound_number, 1, 255, "СΧ");
		if (soundNumber==-1) {
			return;
		}
		settingViewhold.setSoundNumber(soundNumber);
		int sum=16+settingViewhold.getEnter()+settingViewhold.getGapSoundTime()+settingViewhold.getLetter()+settingViewhold.getLongSoundTime()+settingViewhold.getOffPowerTime()
				+settingViewhold.getOffScanTime()+settingViewhold.getScan()+settingViewhold.getShockTime()+settingViewhold.getShortSoundNumber()+settingViewhold.getShortSoundTime()
				+settingViewhold.getSound()+settingViewhold.getSoundNumber();
		boolean setSetting = helper.setSetting(new byte[]{0x02,13,(byte)settingViewhold.getLongSoundTime(),(byte)settingViewhold.getShortSoundTime(),(byte)settingViewhold.getGapSoundTime()
				,(byte)settingViewhold.getShortSoundNumber(),(byte)settingViewhold.getShockTime(),(byte)settingViewhold.getEnter(),(byte)settingViewhold.getLetter()
				,(byte)settingViewhold.getSoundNumber(),1,(byte)settingViewhold.getOffScanTime(),(byte)settingViewhold.getOffPowerTime(),(byte)settingViewhold.getScan()
				,(byte)settingViewhold.getSound(),(byte)sum
		});
		if (setSetting) {
			int shock=1;
			switch (rg_shock.getCheckedRadioButtonId()) {
			case R.id.rb_shock_yes:
				shock=1;
				break;
			case R.id.rb_shock_no:
				shock=0;
				break;

			default:
				break;
			}
			if(helper.setShock(shock)){
				Util.ToastMessage(mContext, "޸ĳɹ");
			}else{
				Util.ToastMessage(mContext, "޸ʧ");
			}
		}else {
			Util.ToastMessage(mContext, "޸ʧ");
		}
	}
}
